ANEW WEEDIT
( editors is managed by a circular single link list,
  GWL_USERDATA stores the link field )
VARIABLE hFile
VARIABLE ReadByte
VARIABLE WriteByte
VARIABLE HandlerReturn
VARIABLE LINE#
VARIABLE NONAMECOUNTER 1 NONAMECOUNTER !
VARIABLE STATUSBAR 
VARIABLE THISEDIT 0 THISEDIT !        \ handle to focal edit control
VARIABLE LASTEDITOR 0 LASTEDITOR !    \ handle of newly created editor
CREATE FILENAME $100 ALLOT   
CREATE FILENAMEFILTER $," orth Files (*.F)"  $," .f" $," ll Files (*.*)" $," .*" 0 c, 
$46 FILENAMEFILTER c!
$2A FILENAMEFILTER $12 + c!   \ this is a hack
$41 FILENAMEFILTER $16 + c!
$2A FILENAMEFILTER $26 + c!


CREATE SBPARTS $40 , $80 , $F0 , $12A , -1 ,
CREATE OPENFILENAME 
$4C ,                                         \ lStructSize; 
HWND ,                                        \ hwndOwner; 
HINST ,                                       \ hInstance; 
FILENAMEFILTER ,                              \ lpstrFilter; 
0 ,                                           \ lpstrCustomFilter; 
0 ,                                           \ nMaxCustFilter; 
0 ,                                           \ nFilterIndex; 
FILENAME ,                                    \ lpstrFile   
$FF ,                                         \ nMaxFile; 
0 ,                                           \ lpstrFileTitle; 
0 ,                                           \ nMaxFileTitle; 
0 ,                                           \ lpstrInitialDir; 
0 ,                                           \ lpstrTitle; 
OFN_FILEMUSTEXIST OFN_PATHMUSTEXIST OR ,      \ Flags; 
0 ,                                           \ nFileOffset nFileExtension 
0 ,                                           \ lpstrDefExt; 
0 ,                                           \ lCustData; 
0 ,                                           \ lpfnHook; 
0 ,                                           \ lpTemplateName;



$101 CONSTANT EDITID
$102 CONSTANT STATUSBARID
VARIABLE DefEditProc

: >LINK ( hWnd -- value )             \ get link field
  GetUserData
;

: LINK ( hWnd newwnd -- oldwnd )      \ link hWnd with newwnd, return oldvalue
  SetUserData 
;

VARIABLE NEXTWND

: LINK> ( hWnd -- hLinkBY )           \ find the window link to hWnd 
  DUP >LINK                           ( hWnd NextWnd -- )
  BEGIN      
    DUP NEXTWND !                     \ save NextWnd
    DUP 0 = IF EXIT THEN              \ in case of invalid link field
    >LINK OVER =                      ( hWnd T/F ) \ compare hWnd with NextWnd-link
    IF DROP NEXTWND @ EXIT THEN       \ found the window link to this window
    NEXTWND @ >LINK
  AGAIN
;

: INSERTEDITOR ( newwnd -- )          \ insert edit window into link list
  LASTEDITOR @ 0 = IF
    DUP LASTEDITOR !                  \ handle first edit window
    DUP LASTEDITOR @ LINK DROP
  THEN
  
  DUP LASTEDITOR @ OVER               ( newwnd newwnd lasteditor newwnd )
  LINK                                ( newwnd newwnd oldlink ) \ link lasteditor to newwindow   
  LINK DROP                           \ link newwindow to lasteditor-link
  LASTEDITOR !                        \ set lasteditor to newwnd
;

: REMOVEEDITOR  ( hWnd -- )           \ remove from link list, linkby->linkto 
  DUP LINK>                           ( hWnd linkby -- )
  SWAP >LINK                          ( linkby linkto -- )
  LINK DROP
;
: CLOSEFILE ( hFile -- )
  CloseHandle DROP
;  
: EDITORFILENAME ( hWnd -- )  \ get editing file name into FILENAME
  &DefWindowProcA SWAP WM_GETTEXT $FF FILENAME CallWindowProcA DROP
;

: ?MODIFIED ( hEdit -- )            \ return true if file is modified
  DefEditProc @ SWAP EM_GETMODIFY 0 0 CallWindowProcA 
;

: CREATEFILE ( zfilename flag -- hFile )
  >R
  GENERIC_READ GENERIC_WRITE OR 
  FILE_SHARE_READ
  0
  R>
  FILE_ATTRIBUTE_ARCHIVE
  0 
  CreateFileA 
;

: OPENFILE  ( cfilename -- hFile ) \ return handle, full filename in FILENAME
  DUP C@ 0 = IF
    DROP
    FILENAME $100 0 FILL
    hWnd @ OPENFILENAME CELL+ !     \ set owner to this window
    OPENFILENAME GetOpenFileNameA IF
      FILENAME
    ELSE
      NONAMECOUNTER @ <# #S $74 HOLD $69 HOLD $64 HOLD $45 HOLD #> DROP
      1 NONAMECOUNTER +!
    THEN
  ELSE
    1+  \ skip count byte
  THEN
  $100 FILENAME 0 GetFullPathNameA DROP    \ expand to full fillname
  
  FILENAME                                 \ skip count byte
  OPEN_EXISTING
  CREATEFILE
;

: WRITEFILE ( hFile -- )
  FLOADBUF  ( hFile Buffer )
  DefEditProc @ THISEDIT @ WM_GETTEXT FLOADBUFLEN FLOADBUF CallWindowProcA 
  WriteByte
  0
  WriteFile IF
    THISEDIT @ EM_SETMODIFY 0 0 SendMessageA DROP
    &DefWindowProcA hWnd @ WM_SETTEXT 0 FILENAME  CallWindowProcA DROP
  ELSE
    ." Error writing file"
  THEN
;

: SAVEFILEAS ( -- )
  hWnd @ EDITORFILENAME        \ get editor filename on caption
  hWnd @ OPENFILENAME CELL+ !  \ set owner to this window
  OPENFILENAME GetSaveFileNameA IF
    &DefWindowProcA hWnd @ WM_SETTEXT 0 FILENAME CallWindowProcA DROP
    FILENAME  CREATE_ALWAYS
 CREATEFILE hFile !
    hFile @ WRITEFILE 
    hFile @ CloseHandle DROP
  THEN
;

: SAVEFILE
  hWnd @ EDITORFILENAME FILENAME TRUNCATE_EXISTING CREATEFILE hFile !
  hFile @ -1 =                  \ file not exist
  IF 
    SAVEFILEAS
  ELSE 
    hFile @ WRITEFILE 
    hFile @ CloseHandle DROP
  THEN
;

: QUITFILE
  hWnd @ WM_CLOSE 0 0 SendMessageA DROP
;

: MAKEINVISIBLE ( hWnd --)
  GWL_STYLE 2DUP
  GetWindowLongA WS_VISIBLE NOT AND
  SetWindowLongA DROP
;

: MAKEVISIBLE ( hWnd --)
  GWL_STYLE 2DUP
  GetWindowLongA WS_VISIBLE OR
  SetWindowLongA DROP
;
  
: INSERTSTRING ( zbuf -- )  \ insert null terminate string into edit control
  >R
  THISEDIT @ WM_GETTEXTLENGTH 0 0 SendMessageA >R  
  THISEDIT @ EM_SETSEL     R> DUP SendMessageA DROP
  THISEDIT @ EM_REPLACESEL 0  R>  SendMessageA DROP
;

: READTOEDIT  ( hFile -- )
  hFile !
  THISEDIT @ MAKEINVISIBLE
  BEGIN                         
      hFile @ PAD FREESPACE $2000 - ReadByte 0 ReadFile DROP
      0 PAD ReadByte @ + !        \ store null terminator
      PAD INSERTSTRING
  ReadByte @ 0 =  UNTIL
  THISEDIT @ EM_SETSEL 0 0 SendMessageA DROP
  THISEDIT @ EM_SCROLLCARET 0 0 SendMessageA DROP
  THISEDIT @ EM_SETMODIFY 0 0 SendMessageA  DROP
  THISEDIT @ MAKEVISIBLE
;


: COMPILEFILE
  FLOADBUF 
  DefEditProc @ THISEDIT @ WM_GETTEXT FLOADBUFLEN FLOADBUF CallWindowProcA BLOAD
;

: COMPILELINE
  DefEditProc @ THISEDIT @ EM_LINEFROMCHAR -1 0 CallWindowProcA >R
  FLOADBUF DefEditProc @ THISEDIT @ EM_GETLINE R> FLOADBUF CallWindowProcA BLOAD
;

: FLOADFILE
  hWnd @ EDITORFILENAME FILENAME doFLOAD
;

: TOCONSOLE
  HCONSOLE SetFocus DROP
;


: SWITCHWINDOW  ( hWnd -- )         \ SetFocus to hWnd
  EDITID GetDlgItem SetFocus
;

: PREVFILE ( hEdit -- )
  GetParent DUP >LINK SWITCHWINDOW 
;

: NEXTFILE ( hEdit -- )
  GetParent DUP  LINK> SWITCHWINDOW 
;

VARIABLE SelStart 
: UPDATEFILESTATUS ( hStatusBar -- )

  STATUSBAR !
  BASE @ >R $A BASE !
\ Line :
  DefEditProc @ THISEDIT @ EM_LINEFROMCHAR -1 0 CallWindowProcA  LINE# ! 
  STATUSBAR @ SB_SETTEXT 0 LINE# @ 1+ <# #S $20  HOLD $6E  HOLD $4C HOLD #> DROP SendMessageA DROP
  
  DefEditProc @ THISEDIT @ EM_GETSEL SelStart 0 CallWindowProcA DROP
  SelStart @ 
  DefEditProc @ THISEDIT @ EM_LINEINDEX LINE# @ 0 CallWindowProcA
  - 1+ >R
  STATUSBAR @ SB_SETTEXT 1 R> <# #S $20 HOLD $6C HOLD $6F HOLD  $43 HOLD #> DROP SendMessageA DROP
  
  
\ File Size:
  DefEditProc @ THISEDIT @ WM_GETTEXTLENGTH 0 0 CallWindowProcA >R
  STATUSBAR @ SB_SETTEXT 2  R> 
   <# #S $20 HOLD $65 HOLD $7A HOLD $69 HOLD $53 HOLD #> DROP 
  SendMessageA DROP

\ Modified flag

  DefEditProc @ THISEDIT @ EM_GETMODIFY 0 0 CallWindowProcA 
  IF Z" Modified" ELSE Z" Saved" THEN >R
  STATUSBAR @ SB_SETTEXT 3 R> SendMessageA DROP
    
  R> BASE !
;

: EDITPROC ( hWnd uMsg wParam lParam -- res )
  
  lParam ! wParam ! uMsg ! THISEDIT !
  uMsg @ WM_KEYUP = IF
    THISEDIT @ 
    $71 wParam @ = IF SAVEFILE THEN     \ F2
    $72 wParam @ = IF SAVEFILEAS THEN   \ F3
    $73 wParam @ = IF QUITFILE THEN     \ F4
    $75 wParam @ = IF COMPILELINE THEN  \ F6
    $76 wParam @ = IF COMPILEFILE THEN  \ F7
    $77 wParam @ = IF COMPILEFILE THEN  \ F8
    $78 wParam @ = IF TOCONSOLE THEN    \ F9
    $7A wParam @ = IF PREVFILE THEN     \ F11
    $7B wParam @ = IF NEXTFILE THEN     \ F12
    DROP
    
  THEN
  
  DefEditProc @ THISEDIT @ uMsg @ wParam @ lParam @ CallWindowProcA HandlerReturn !
  THISEDIT @ GetParent STATUSBARID GetDlgItem  UPDATEFILESTATUS 
  HandlerReturn @
;
: EDITORPROC ( hWnd uMsg wParam lParam -- res )
  GETMSGPARA
  hWnd @ EDITID GetDlgItem THISEDIT !
  
  uMsg @ WM_SIZE = IF
    hWnd @ RECT GetClientRect DROP
    hWnd @ STATUSBARID GetDlgItem STATUSBAR ! 
    STATUSBAR @ 0 RECT.BOTTOM @ $14 - RECT.RIGHT @ RECT.BOTTOM @ -1 MoveWindow DROP
    STATUSBAR @ SB_SETPARTS 5 SBPARTS SendMessageA DROP
    STATUSBAR @ SB_SETTEXT 4 Z" F2:Save F3:SaveAs F4:Quit F6:CompileLine F7:CompileBuffer F8:CompileFile F9:Console F11:Prev F12:Next" SendMessageA DROP
    THISEDIT @ 0 0 RECT.RIGHT @ RECT.BOTTOM @ $1B - -1 MoveWindow DROP
    STATUSBAR @ UPDATEFILESTATUS
  THEN 
  
  uMsg @ WM_ACTIVATE = IF
    hWnd @ EDITID GetDlgItem SetFocus DROP
  THEN
  
  uMsg @ WM_CLOSE = IF
    THISEDIT @ ?MODIFIED IF
      hWnd @ Z" Save changes before quit?" Z" WeEditor" MB_YESNOCANCEL MB_ICONEXCLAMATION OR MessageBoxA
      DUP IDCANCEL = IF DROP EXIT THEN
      IDYES = IF SAVEFILE THEN
    THEN
    hWnd @ DestroyWindow DROP
  THEN
  
  
   uMsg @ WM_DESTROY = IF
     hWnd @ REMOVEEDITOR
   THEN
  
  hWnd @ uMsg @ wParam @ lParam @ DefWindowProcA HandlerReturn !
  HandlerReturn @
;

' EDITPROC MESSAGEHANDLER: &EDITPROC
' EDITORPROC MESSAGEHANDLER: &EDITORPROC

: EDITORONCREATE ( hWnd  -- )
  hWnd !
  0 
  Z" EDIT"
  0
  $50200104     \ WS_CHILD+WS_VISIBLE+WS_VSCROLL+ES_NOHIDESEL+ES_MULTILINE
  CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  hWnd @
  EDITID
  HINST
  0
  CreateWindowExA THISEDIT !
  THISEDIT @ GWL_WNDPROC &EDITPROC SetWindowLongA DefEditProc !
  THISEDIT @ SetFocus DROP
  THISEDIT @ WM_SETFONT
  SYSTEM_FIXED_FONT GetStockObject 0 SendMessageA DROP

  0
  Z" msctls_statusbar32"
  0
  $50800010
  CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT CW_USEDEFAULT
  hWnd @
  STATUSBARID
  HINST
  0
  CreateWindowExA DROP
;
: EDITFILE ( cfilename -- )
  OPENFILE hFile !
  \ see if the file is open in another window
  FORMCLASSNAME FILENAME FindWindowA ?DUP IF
    SetActiveWindow DROP                   \ switch to the window 
    hFile @ CloseHandle DROP               \ instead of open a new one
    EXIT
  THEN
  
  0 
  Z" WeForm" 
  FILENAME                                 \ filename  as caption
  $10CF0000
  CW_USEDEFAULT CW_USEDEFAULT 380 200
  \ 50 50 300 150
  0
  0
  HINST
  0
  CreateWindowExA hWnd !

  hWnd @ INSERTEDITOR
  hWnd @ EDITORONCREATE
  hWnd @ GWL_WNDPROC &EDITORPROC SetWindowLongA DROP
  hWnd @ WM_SIZE 0 0 SendMessageA DROP
  
  hFile @ -1 = IF ELSE
    hFile @ DUP READTOEDIT CloseHandle DROP
  THEN
;  

: EDIT  ( -filename- )                    \ open an editor window
  FILENAME $100 0 FILL
  BL WORD EDITFILE
;

: test
  BL WORD OPENFILE . .
;
